<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/ContextManager/include/ContextManager/ContextManager.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_ed284a04dd0d49c135ac897057737ac2.html">ContextManager</a></li><li class="navelem"><a class="el" href="dir_0f8ea464962f792f3167c26165597ec0.html">include</a></li><li class="navelem"><a class="el" href="dir_f1d622a5ac9338dd342c480f8157dab5.html">ContextManager</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ContextManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_context_manager_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CONTEXTMANAGER_INCLUDE_CONTEXTMANAGER_CONTEXTMANAGER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CONTEXTMANAGER_INCLUDE_CONTEXTMANAGER_CONTEXTMANAGER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;queue&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;unordered_set&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;rapidjson/document.h&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;rapidjson/stringbuffer.h&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;rapidjson/writer.h&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_context_manager_interface_8h.html">AVSCommon/SDKInterfaces/ContextManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_context_requester_interface_8h.html">AVSCommon/SDKInterfaces/ContextRequesterInterface.h</a>&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_state_provider_interface_8h.html">AVSCommon/SDKInterfaces/StateProviderInterface.h</a>&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_state_refresh_policy_8h.html">AVSCommon/AVS/StateRefreshPolicy.h</a>&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_namespace_and_name_8h.html">AVSCommon/AVS/NamespaceAndName.h</a>&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1context_manager.html">   39</a></span>&#160;<span class="keyword">namespace </span>contextManager {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html">   45</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html">ContextManager</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface.html">avsCommon::sdkInterfaces::ContextManagerInterface</a> {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;ContextManager&gt; <a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#a1a671e2a16da302721a67de7706f32a7">create</a>();</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#a0bcd84726259d11b954147ffaaf23d21">~ContextManager</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#a6e2f8a00f8c548b8ab661fb5a876ef46">setStateProvider</a>(</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; stateProviderName,</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::StateProviderInterface&gt; stateProvider) <span class="keyword">override</span>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a10a3cb8dea046c68b6cd5b82c0bedbdb">avsCommon::sdkInterfaces::SetStateResult</a> <a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#aa95cbfc4b7ba09a05b242af788fc1692">setState</a>(</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; stateProviderName,</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keyword">const</span> std::string&amp; jsonState,</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7c">avsCommon::avs::StateRefreshPolicy</a>&amp; refreshPolicy,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> stateRequestToken = 0) <span class="keyword">override</span>;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#adbca3d2b995a1a22f1876012ce7d30b2">getContext</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextRequesterInterface&gt; contextRequester) <span class="keyword">override</span>;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">struct </span>StateInfo {</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::StateProviderInterface&gt; stateProvider;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        std::string jsonState;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7c">avsCommon::avs::StateRefreshPolicy</a> refreshPolicy;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        StateInfo(</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            std::shared_ptr&lt;avsCommon::sdkInterfaces::StateProviderInterface&gt; initStateProvider = <span class="keyword">nullptr</span>,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            std::string initJsonState = <span class="stringliteral">&quot;&quot;</span>,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7c">avsCommon::avs::StateRefreshPolicy</a> initRefreshPolicy = <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7caf3fc827ade4b968e50406496907ef962">avsCommon::avs::StateRefreshPolicy::ALWAYS</a>);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    };</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html">ContextManager</a>();</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordtype">void</span> init();</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a10a3cb8dea046c68b6cd5b82c0bedbdb">avsCommon::sdkInterfaces::SetStateResult</a> updateStateLocked(</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; stateProviderName,</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        <span class="keyword">const</span> std::string&amp; jsonState,</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7c">avsCommon::avs::StateRefreshPolicy</a>&amp; refreshPolicy);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">void</span> requestStatesLocked(std::unique_lock&lt;std::mutex&gt;&amp; stateProviderLock);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordtype">void</span> sendContextAndClearQueue(</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keyword">const</span> std::string&amp; context,</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018">avsCommon::sdkInterfaces::ContextRequestError</a>&amp; contextRequestError =</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018ad7f5137f80b534b3740829379bc9489f">avsCommon::sdkInterfaces::ContextRequestError::BUILD_CONTEXT_ERROR</a>);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keywordtype">void</span> updateStatesLoop();</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    rapidjson::Value buildHeader(</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; namespaceAndName,</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        rapidjson::Document::AllocatorType&amp; allocator);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    rapidjson::Value buildState(</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avsCommon::avs::NamespaceAndName</a>&amp; namespaceAndName,</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keyword">const</span> std::string jsonPayloadValue,</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        rapidjson::Document::AllocatorType&amp; allocator);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordtype">void</span> sendContextToRequesters();</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    std::unordered_map&lt;avsCommon::avs::NamespaceAndName, std::shared_ptr&lt;StateInfo&gt;&gt; m_namespaceNameToStateInfo;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    std::queue&lt;std::shared_ptr&lt;avsCommon::sdkInterfaces::ContextRequesterInterface&gt;&gt; m_contextRequesterQueue;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    std::unordered_set&lt;avsCommon::avs::NamespaceAndName&gt; m_pendingOnStateProviders;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    std::mutex m_stateProviderMutex;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    std::mutex m_contextRequesterMutex;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    std::thread m_updateStatesThread;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    std::condition_variable m_setStateCompleteNotifier;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    std::condition_variable m_contextLoopNotifier;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="comment">     * Token to recognize the which @c getContext request the @c setState updates are being provided for.</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="comment">     * The value is updated before @c provideState request is issued to the @c StateProviderInterfaces. The</span></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="comment">     * @c m_stateProviderMutex must be acquired before modifying or reading the value.</span></div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_stateRequestToken;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <span class="comment">/*</span></div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="comment">     * Whether the contextManager is shutting down. The @c m_contextRequesterMutex is acquired before this value is</span></div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="comment">     * modified or read.</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;<span class="comment">     */</span></div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keywordtype">bool</span> m_shutdown;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;};</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;}  <span class="comment">// namespace contextManager</span></div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CONTEXTMANAGER_INCLUDE_CONTEXTMANAGER_CONTEXTMANAGER_H_</span></div><div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_html_a10a3cb8dea046c68b6cd5b82c0bedbdb"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a10a3cb8dea046c68b6cd5b82c0bedbdb">alexaClientSDK::avsCommon::sdkInterfaces::SetStateResult</a></div><div class="ttdeci">SetStateResult</div><div class="ttdef"><b>Definition:</b> ContextManagerInterface.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">alexaClientSDK::avsCommon::avs::NamespaceAndName</a></div><div class="ttdef"><b>Definition:</b> NamespaceAndName.h:28</div></div>
<div class="ttc" id="_state_refresh_policy_8h_html"><div class="ttname"><a href="_state_refresh_policy_8h.html">StateRefreshPolicy.h</a></div></div>
<div class="ttc" id="_state_provider_interface_8h_html"><div class="ttname"><a href="_state_provider_interface_8h.html">StateProviderInterface.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a6dceaef43ef22e8f83382c0072f0cd7caf3fc827ade4b968e50406496907ef962"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7caf3fc827ade4b968e50406496907ef962">alexaClientSDK::avsCommon::avs::StateRefreshPolicy::ALWAYS</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_html_a8ec2f2403294717c740bfacf5c62d018"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018">alexaClientSDK::avsCommon::sdkInterfaces::ContextRequestError</a></div><div class="ttdeci">ContextRequestError</div><div class="ttdef"><b>Definition:</b> ContextRequesterInterface.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a6dceaef43ef22e8f83382c0072f0cd7c"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a6dceaef43ef22e8f83382c0072f0cd7c">alexaClientSDK::avsCommon::avs::StateRefreshPolicy</a></div><div class="ttdeci">StateRefreshPolicy</div><div class="ttdef"><b>Definition:</b> StateRefreshPolicy.h:27</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager_html_a1a671e2a16da302721a67de7706f32a7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#a1a671e2a16da302721a67de7706f32a7">alexaClientSDK::contextManager::ContextManager::create</a></div><div class="ttdeci">static std::shared_ptr&lt; ContextManager &gt; create()</div><div class="ttdef"><b>Definition:</b> ContextManager.cpp:59</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager_html_a6e2f8a00f8c548b8ab661fb5a876ef46"><div class="ttname"><a href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#a6e2f8a00f8c548b8ab661fb5a876ef46">alexaClientSDK::contextManager::ContextManager::setStateProvider</a></div><div class="ttdeci">void setStateProvider(const avsCommon::avs::NamespaceAndName &amp;stateProviderName, std::shared_ptr&lt; avsCommon::sdkInterfaces::StateProviderInterface &gt; stateProvider) override</div><div class="ttdef"><b>Definition:</b> ContextManager.cpp:76</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager_html_a0bcd84726259d11b954147ffaaf23d21"><div class="ttname"><a href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#a0bcd84726259d11b954147ffaaf23d21">alexaClientSDK::contextManager::ContextManager::~ContextManager</a></div><div class="ttdeci">~ContextManager() override</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> ContextManager.cpp:65</div></div>
<div class="ttc" id="_context_manager_interface_8h_html"><div class="ttname"><a href="_context_manager_interface_8h.html">ContextManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html">alexaClientSDK::contextManager::ContextManager</a></div><div class="ttdef"><b>Definition:</b> ContextManager.h:45</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_context_manager_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::ContextManagerInterface</a></div><div class="ttdef"><b>Definition:</b> ContextManagerInterface.h:55</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_html_a8ec2f2403294717c740bfacf5c62d018ad7f5137f80b534b3740829379bc9489f"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html#a8ec2f2403294717c740bfacf5c62d018ad7f5137f80b534b3740829379bc9489f">alexaClientSDK::avsCommon::sdkInterfaces::ContextRequestError::BUILD_CONTEXT_ERROR</a></div><div class="ttdoc">getContext request failed due to an error building the context. </div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager_html_aa95cbfc4b7ba09a05b242af788fc1692"><div class="ttname"><a href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#aa95cbfc4b7ba09a05b242af788fc1692">alexaClientSDK::contextManager::ContextManager::setState</a></div><div class="ttdeci">avsCommon::sdkInterfaces::SetStateResult setState(const avsCommon::avs::NamespaceAndName &amp;stateProviderName, const std::string &amp;jsonState, const avsCommon::avs::StateRefreshPolicy &amp;refreshPolicy, const unsigned int stateRequestToken=0) override</div><div class="ttdef"><b>Definition:</b> ContextManager.cpp:96</div></div>
<div class="ttc" id="_namespace_and_name_8h_html"><div class="ttname"><a href="_namespace_and_name_8h.html">NamespaceAndName.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager_html_adbca3d2b995a1a22f1876012ce7d30b2"><div class="ttname"><a href="classalexa_client_s_d_k_1_1context_manager_1_1_context_manager.html#adbca3d2b995a1a22f1876012ce7d30b2">alexaClientSDK::contextManager::ContextManager::getContext</a></div><div class="ttdeci">void getContext(std::shared_ptr&lt; avsCommon::sdkInterfaces::ContextRequesterInterface &gt; contextRequester) override</div><div class="ttdef"><b>Definition:</b> ContextManager.cpp:133</div></div>
<div class="ttc" id="_context_requester_interface_8h_html"><div class="ttname"><a href="_context_requester_interface_8h.html">ContextRequesterInterface.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
